/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.analytics.settings.rest.dto.v1_0;

import com.fasterxml.jackson.annotation.JsonFilter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import com.liferay.petra.function.UnsafeSupplier;
import com.liferay.petra.string.StringBundler;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.vulcan.graphql.annotation.GraphQLField;
import com.liferay.portal.vulcan.graphql.annotation.GraphQLName;
import com.liferay.portal.vulcan.util.ObjectMapperUtil;

import io.swagger.v3.oas.annotations.media.Schema;

import java.io.Serializable;

import java.util.Iterator;
import java.util.Map;
import java.util.Objects;
import java.util.Set;

import javax.annotation.Generated;

import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author Riccardo Ferrari
 * @generated
 */
@Generated("")
@GraphQLName("ContactConfiguration")
@JsonFilter("Liferay.Vulcan")
@XmlRootElement(name = "ContactConfiguration")
public class ContactConfiguration implements Serializable {

	public static ContactConfiguration toDTO(String json) {
		return ObjectMapperUtil.readValue(ContactConfiguration.class, json);
	}

	public static ContactConfiguration unsafeToDTO(String json) {
		return ObjectMapperUtil.unsafeReadValue(
			ContactConfiguration.class, json);
	}

	@Schema
	public Boolean getSyncAllAccounts() {
		return syncAllAccounts;
	}

	public void setSyncAllAccounts(Boolean syncAllAccounts) {
		this.syncAllAccounts = syncAllAccounts;
	}

	@JsonIgnore
	public void setSyncAllAccounts(
		UnsafeSupplier<Boolean, Exception> syncAllAccountsUnsafeSupplier) {

		try {
			syncAllAccounts = syncAllAccountsUnsafeSupplier.get();
		}
		catch (RuntimeException re) {
			throw re;
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@GraphQLField
	@JsonProperty(access = JsonProperty.Access.READ_WRITE)
	protected Boolean syncAllAccounts;

	@Schema
	public Boolean getSyncAllContacts() {
		return syncAllContacts;
	}

	public void setSyncAllContacts(Boolean syncAllContacts) {
		this.syncAllContacts = syncAllContacts;
	}

	@JsonIgnore
	public void setSyncAllContacts(
		UnsafeSupplier<Boolean, Exception> syncAllContactsUnsafeSupplier) {

		try {
			syncAllContacts = syncAllContactsUnsafeSupplier.get();
		}
		catch (RuntimeException re) {
			throw re;
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@GraphQLField
	@JsonProperty(access = JsonProperty.Access.READ_WRITE)
	protected Boolean syncAllContacts;

	@Schema
	public String[] getSyncedAccountGroupIds() {
		return syncedAccountGroupIds;
	}

	public void setSyncedAccountGroupIds(String[] syncedAccountGroupIds) {
		this.syncedAccountGroupIds = syncedAccountGroupIds;
	}

	@JsonIgnore
	public void setSyncedAccountGroupIds(
		UnsafeSupplier<String[], Exception>
			syncedAccountGroupIdsUnsafeSupplier) {

		try {
			syncedAccountGroupIds = syncedAccountGroupIdsUnsafeSupplier.get();
		}
		catch (RuntimeException re) {
			throw re;
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@GraphQLField
	@JsonProperty(access = JsonProperty.Access.READ_WRITE)
	protected String[] syncedAccountGroupIds;

	@Schema
	public String[] getSyncedOrganizationIds() {
		return syncedOrganizationIds;
	}

	public void setSyncedOrganizationIds(String[] syncedOrganizationIds) {
		this.syncedOrganizationIds = syncedOrganizationIds;
	}

	@JsonIgnore
	public void setSyncedOrganizationIds(
		UnsafeSupplier<String[], Exception>
			syncedOrganizationIdsUnsafeSupplier) {

		try {
			syncedOrganizationIds = syncedOrganizationIdsUnsafeSupplier.get();
		}
		catch (RuntimeException re) {
			throw re;
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@GraphQLField
	@JsonProperty(access = JsonProperty.Access.READ_WRITE)
	protected String[] syncedOrganizationIds;

	@Schema
	public String[] getSyncedUserGroupIds() {
		return syncedUserGroupIds;
	}

	public void setSyncedUserGroupIds(String[] syncedUserGroupIds) {
		this.syncedUserGroupIds = syncedUserGroupIds;
	}

	@JsonIgnore
	public void setSyncedUserGroupIds(
		UnsafeSupplier<String[], Exception> syncedUserGroupIdsUnsafeSupplier) {

		try {
			syncedUserGroupIds = syncedUserGroupIdsUnsafeSupplier.get();
		}
		catch (RuntimeException re) {
			throw re;
		}
		catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	@GraphQLField
	@JsonProperty(access = JsonProperty.Access.READ_WRITE)
	protected String[] syncedUserGroupIds;

	@Override
	public boolean equals(Object object) {
		if (this == object) {
			return true;
		}

		if (!(object instanceof ContactConfiguration)) {
			return false;
		}

		ContactConfiguration contactConfiguration =
			(ContactConfiguration)object;

		return Objects.equals(toString(), contactConfiguration.toString());
	}

	@Override
	public int hashCode() {
		String string = toString();

		return string.hashCode();
	}

	public String toString() {
		StringBundler sb = new StringBundler();

		sb.append("{");

		if (syncAllAccounts != null) {
			if (sb.length() > 1) {
				sb.append(", ");
			}

			sb.append("\"syncAllAccounts\": ");

			sb.append(syncAllAccounts);
		}

		if (syncAllContacts != null) {
			if (sb.length() > 1) {
				sb.append(", ");
			}

			sb.append("\"syncAllContacts\": ");

			sb.append(syncAllContacts);
		}

		if (syncedAccountGroupIds != null) {
			if (sb.length() > 1) {
				sb.append(", ");
			}

			sb.append("\"syncedAccountGroupIds\": ");

			sb.append("[");

			for (int i = 0; i < syncedAccountGroupIds.length; i++) {
				sb.append("\"");

				sb.append(_escape(syncedAccountGroupIds[i]));

				sb.append("\"");

				if ((i + 1) < syncedAccountGroupIds.length) {
					sb.append(", ");
				}
			}

			sb.append("]");
		}

		if (syncedOrganizationIds != null) {
			if (sb.length() > 1) {
				sb.append(", ");
			}

			sb.append("\"syncedOrganizationIds\": ");

			sb.append("[");

			for (int i = 0; i < syncedOrganizationIds.length; i++) {
				sb.append("\"");

				sb.append(_escape(syncedOrganizationIds[i]));

				sb.append("\"");

				if ((i + 1) < syncedOrganizationIds.length) {
					sb.append(", ");
				}
			}

			sb.append("]");
		}

		if (syncedUserGroupIds != null) {
			if (sb.length() > 1) {
				sb.append(", ");
			}

			sb.append("\"syncedUserGroupIds\": ");

			sb.append("[");

			for (int i = 0; i < syncedUserGroupIds.length; i++) {
				sb.append("\"");

				sb.append(_escape(syncedUserGroupIds[i]));

				sb.append("\"");

				if ((i + 1) < syncedUserGroupIds.length) {
					sb.append(", ");
				}
			}

			sb.append("]");
		}

		sb.append("}");

		return sb.toString();
	}

	@Schema(
		accessMode = Schema.AccessMode.READ_ONLY,
		defaultValue = "com.liferay.analytics.settings.rest.dto.v1_0.ContactConfiguration",
		name = "x-class-name"
	)
	public String xClassName;

	private static String _escape(Object object) {
		return StringUtil.replace(
			String.valueOf(object), _JSON_ESCAPE_STRINGS[0],
			_JSON_ESCAPE_STRINGS[1]);
	}

	private static boolean _isArray(Object value) {
		if (value == null) {
			return false;
		}

		Class<?> clazz = value.getClass();

		return clazz.isArray();
	}

	private static String _toJSON(Map<String, ?> map) {
		StringBuilder sb = new StringBuilder("{");

		@SuppressWarnings("unchecked")
		Set set = map.entrySet();

		@SuppressWarnings("unchecked")
		Iterator<Map.Entry<String, ?>> iterator = set.iterator();

		while (iterator.hasNext()) {
			Map.Entry<String, ?> entry = iterator.next();

			sb.append("\"");
			sb.append(_escape(entry.getKey()));
			sb.append("\": ");

			Object value = entry.getValue();

			if (_isArray(value)) {
				sb.append("[");

				Object[] valueArray = (Object[])value;

				for (int i = 0; i < valueArray.length; i++) {
					if (valueArray[i] instanceof String) {
						sb.append("\"");
						sb.append(valueArray[i]);
						sb.append("\"");
					}
					else {
						sb.append(valueArray[i]);
					}

					if ((i + 1) < valueArray.length) {
						sb.append(", ");
					}
				}

				sb.append("]");
			}
			else if (value instanceof Map) {
				sb.append(_toJSON((Map<String, ?>)value));
			}
			else if (value instanceof String) {
				sb.append("\"");
				sb.append(_escape(value));
				sb.append("\"");
			}
			else {
				sb.append(value);
			}

			if (iterator.hasNext()) {
				sb.append(", ");
			}
		}

		sb.append("}");

		return sb.toString();
	}

	private static final String[][] _JSON_ESCAPE_STRINGS = {
		{"\\", "\"", "\b", "\f", "\n", "\r", "\t"},
		{"\\\\", "\\\"", "\\b", "\\f", "\\n", "\\r", "\\t"}
	};

}